package com.vendor.loader.struct;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.loader.Messages;
import com.vendor.loader.struct.BurnType;
import com.vendor.loader.struct.FileSystem;
import com.vendor.loader.struct.FlashType;
import com.vendor.loader.util.LoaderException;
import java.io.File;

public class UpgradeFileInfo {
  private String partitionName;
  
  private int partitionVersion;
  
  private int partitionVerifyTag;
  
  private String fileName = "";
  
  private long startAddress = 0L;
  
  private long endAddress = 0L;
  
  private FlashType flashType = FlashType.nand;
  
  private BurnType burnType = BurnType.BURN_TYPE_RAW;
  
  private FileSystem fileSystem = FileSystem.none;
  
  private int flashIndex = 0;
  
  private static final String compareString = "<>&\"'";
  
  private long fileLength;
  
  private long length;
  
  private boolean sel;
  
  public boolean isSel() {
    return this.sel;
  }
  
  public void setSel(boolean sel) {
    this.sel = sel;
  }
  
  public UpgradeFileInfo() {}
  
  public UpgradeFileInfo(boolean sel, String partitionName, int partitionVersion, int partitionVerifyTag, String fileName, long startAddress, long endAddress, FlashType flashType, FileSystem fileSystem, long flashIndex, long fileLength, long length) {
    this.sel = sel;
    this.partitionName = partitionName;
    this.partitionVersion = partitionVersion;
    this.partitionVerifyTag = partitionVerifyTag;
    this.fileName = fileName;
    this.startAddress = startAddress;
    this.endAddress = endAddress;
    this.flashType = flashType;
    this.fileSystem = fileSystem;
    this.flashIndex = (int)flashIndex;
    this.fileLength = (int)fileLength;
    this.length = length;
  }
  
  public void validate() throws LoaderException {
    if (this.fileName == null || this.fileName.length() == 0 || this.startAddress == -1L || this.endAddress == -1L)
      throw new LoaderException(Messages.UpgradeInfoGroup_InputError); 
    File f = new File(this.fileName);
    if (!f.exists())
      throw new LoaderException(String.format(Messages.UpgradeInfoGroup_FileNotFound, new Object[] { this.fileName })); 
    this.fileLength = (int)f.length();
    if (0L == this.fileLength)
      throw new LoaderException(Messages.UpgradeInfoGroup_FileIsEmpty); 
    if (FlashType.emmc != this.flashType || (FlashType.emmc == this.flashType && BurnType.BURN_TYPE_RAW == this.burnType))
      if (this.startAddress + this.fileLength > this.endAddress)
        throw new LoaderException(Messages.UpgradeInfoGroup_BurningSpaceError);  
  }
  
  public void validateFileName() throws LoaderException {
    if (this.fileName == null)
      throw new LoaderException(Messages.UpgradeInfoGroup_InputError); 
    for (int i = 0; i < "<>&\"'".length(); i++) {
      String temp = String.valueOf("<>&\"'".charAt(i));
      if (this.fileName.contains(temp))
        throw new LoaderException(String.format(Messages.UpgradeInfoGroup_InputError, new Object[] { this.fileName })); 
    } 
  }
  
  public String getFileName() {
    return this.fileName;
  }
  
  public void setFileName(String fileName) {
    this.fileName = fileName;
  }
  
  public long getStartAddress() {
    return this.startAddress;
  }
  
  public void setStartAddress(long startAddress) {
    this.startAddress = startAddress;
  }
  
  public long getEndAddress() {
    return this.endAddress;
  }
  
  public void setEndAddress(long endAddress) {
    this.endAddress = endAddress;
  }
  
  public FlashType getFlashType() {
    return this.flashType;
  }
  
  public void setFlashType(FlashType flashType) {
    this.flashType = flashType;
  }
  
  public int getFlashIndex() {
    return this.flashIndex;
  }
  
  public void setFlashIndex(int flashIndex) {
    this.flashIndex = flashIndex;
  }
  
  public long getFileLength() {
    return this.fileLength;
  }
  
  public void setFileLength(long fileLength) {
    this.fileLength = fileLength;
  }
  
  public BurnType getBurnType() {
    return this.burnType;
  }
  
  public void setBurnType(BurnType burnType) {
    this.burnType = burnType;
  }
  
  public FileSystem getFileSystem() {
    return this.fileSystem;
  }
  
  public void setFileSystem(FileSystem fileSystem) {
    this.fileSystem = fileSystem;
  }
  
  public String getPartitionName() {
    return this.partitionName;
  }
  
  public void setPartitionName(String partitionName) {
    this.partitionName = partitionName;
  }
  
  public com.vendor.loader.struct.UpgradeFileInfo copy() {
    com.vendor.loader.struct.UpgradeFileInfo info = new com.vendor.loader.struct.UpgradeFileInfo();
    info.setBurnType(getBurnType());
    info.setFlashIndex(getFlashIndex());
    info.setFlashType(getFlashType());
    info.setFileSystem(getFileSystem());
    info.setLength(getLength());
    info.setPartitionName(getPartitionName());
    info.setPartitionVersion(getPartitionVersion());
    info.setPartitionVerifyTag(getPartitionVerifyTag());
    info.setSel(isSel());
    return info;
  }
  
  public long getLength() {
    return this.length;
  }
  
  public void setLength(long length) {
    this.length = length;
  }
  
  public int getPartitionVersion() {
    return this.partitionVersion;
  }
  
  public void setPartitionVersion(int partitionVersion) {
    this.partitionVersion = partitionVersion;
  }
  
  public int getPartitionVerifyTag() {
    return this.partitionVerifyTag;
  }
  
  public void setPartitionVerifyTag(int partitionVerifyTag) {
    this.partitionVerifyTag = partitionVerifyTag;
  }
}
